#jinja2:trim_blocks:False
global
  log 127.0.0.1 local0
  log 127.0.0.1 local1 notice
  maxconn 4096
  #ssl-default-bind-ciphers kEECDH+aRSA+AES:kRSA+AES:+AES256:RC4-SHA:!kEDH:!LOW:!EXP:!MD5:!aNULL:!eNULL
  tune.ssl.default-dh-param 2048 # not sure
  ssl-default-bind-ciphers ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256:!kEDH:!LOW:!EXP:!MD5:!aNULL:!eNULL
  ssl-default-bind-options ssl-min-ver TLSv1.2 no-tls-tickets

defaults
  log	global
  mode	http
  option	httplog
  option	dontlognull
  timeout connect 5s
  timeout client 1800s
  timeout client-fin 50s
  timeout server 1800s
  timeout tunnel 1h

frontend stats
  bind *:{{haproxy_stats_port}}
  mode http
  stats enable
  stats hide-version
  stats realm Haproxy\ Statistics
  stats uri /haproxy_stats
  stats auth {{ haproxy_user }}:{{ haproxy_passwd }}
  stats refresh 10s
  stats admin if LOCALHOST

#############################
#  api-proxy config
#############################


frontend front-api-proxy
  bind *:{{ha_proxy_port}}
  mode tcp
  option tcplog
  option forwardfor
  default_backend back-api-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-api-proxy
  mode tcp
  option tcplog
  balance roundrobin
  option ssl-hello-chk
  option log-health-checks
  default-server inter 10s fall 2
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:6443 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s
  timeout tunnel 1800s


#############################
#  k8s metrics config
#############################

frontend front-kcm-http-proxy
  bind *:10252
  mode http
  option httplog
  default_backend back-kcm-http-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-kcm-http-proxy
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:10252 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s


frontend front-ksched-http-proxy
  bind *:10251
  mode http
  option httplog
  default_backend back-ksched-http-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-ksched-http-proxy
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:10251 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s


frontend front-kube-state-metrics
  bind *:32080
  mode http
  option httplog
  default_backend back-kube-state-metrics
  timeout client 1800s
  timeout client-fin 50s

backend back-kube-state-metrics
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:32080 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s

frontend front-kube-state-metrics-telemetry
  bind *:32081
  mode http
  option httplog
  default_backend back-kube-state-metrics-telemetry
  timeout client 1800s
  timeout client-fin 50s

backend back-kube-state-metrics-telemetry
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:32081 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s



#############################
#  nginx-proxy config
#############################

frontend front-nginx-http-proxy
  bind *:{{nginx_http_proxy_port}}
  mode http
  option httplog
  default_backend back-nginx-http-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-nginx-http-proxy
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:30080 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s
  timeout tunnel 1800s

frontend front-nginx-https-proxy
  bind *:{{nginx_https_proxy_port}}
  mode tcp
  option tcplog
  option forwardfor
  default_backend back-nginx-https-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-nginx-https-proxy
  mode tcp
  option tcplog
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:30443 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s



#############################
#  gitlab metrics config
#############################

frontend front-gitlab-http-proxy
  bind *:9252
  mode http
  option httplog
  default_backend back-gitlab-http-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-gitlab-http-proxy
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:30929 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s



#############################
#  etcd config
#############################


frontend front-etcd-proxy
  bind *:{{etcd_proxy_port}}
  mode tcp
  option tcplog
  option forwardfor
  default_backend back-etcd-proxy

backend back-etcd-proxy
  mode tcp
  option tcplog
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:2379 check
  {%- endfor %}



#############################
#  minio-proxy config
#############################

frontend front-minio-http-proxy
  bind *:9000
  mode http
  option httplog
  default_backend back-minio-http-proxy
  timeout client 1800s
  timeout client-fin 50s

backend back-minio-http-proxy
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['masters'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:30900 check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s
  timeout tunnel 1800s
